;***************************************
;UNI EDITOR EXIT: A-OUT_OF_LINE CODE
;                 C-PX
;B-PY C-X(BYTE) D-XMIN E-XMAX
;CF=1 CALL END_OF_LINE
;CF=0 A=PX
;CONTINUE=CALL IEDCONT

IED     LD HL,IERET
IED_ADD PUSH AF
        LD (IEPX),A
        LD (IEPROC),HL
        LD A,D,(IEXMIN),A
        LD A,E,(IEXMAX),A
        LD A,B,(IEPY),A
        LD A,C,(BASEX),A
        LD HL,SYST:SET 3,(HL)
        LD A,27:CALL SETBANK
        POP AF:CALL C,IEEND
IEDCONT CALL IED0
        LD HL,SYST
        BIT 2,(HL):RES 2,(HL)
        PUSH AF:CALL NZ,PRLN2
        LD A,(IEPX),C,A
        POP AF:RET

IEDB    LD A,(COLERR2):OUT (#FE)
IED0    LD HL,(IEPX),A,(BASEX)
        CALL CURON
        CALL PRCOL
        CALL PRLN
        CALL WTKEY
        LD A,(BRDCOL):OUT (#FE),A
LASTK   EQU $+1:LD A,0:CP #20:JR C,IED2
        CALL IESETCH,IESETC1
        LD HL,(IEPX),H,BUFED[:INC L
        BIT 7,C:JR Z,IED1
        LD B,A
        LD A,(BUFED+80):CP 32:JR NZ,IEDB
        LD A,80:SUB L:LD C,A
        LD A,B:LD B,0
        LD HL,BUFED+79,DE,BUFED+80
        LDDR:EX DE,HL
IED1    LD (HL),A
        LD A,(IEPX):CALL IERGT1:JR IED0

IED2    ADD A,A:ADD A,IEDTBL]:LD L,A
        ADC A,IEDTBL[:SUB L:LD H,A
        LD A,(HL):INC HL
        LD H,(HL):LD L,A
        LD A,H:OR A:LD A,L:RET Z;OUTLINE
        CALL IESETC1
        LD DE,IED0:PUSH DE
        LD DE,(IEPX):JP (HL)

IEDTBL  DW 0,1,IECLR,2,3,4,5,6,IELFT
        DW IERGT,7,8,IEBSP,10,11,IEDEL
        DW IEBSPW,IERLAT,IECLOCK,13,14
        DW IELFTW,15,16,IERGTW,IEDELW
        DW 17,IEHOM,IEINS,IEEND
        DW IERET,IERET

IESETCH PUSH HL:LD HL,SYST
        RES 1,(HL):POP HL:RET

IESETC1 PUSH HL:LD HL,SYST
        RES 3,(HL):POP HL:RET

IERLAT  LD A,#04:JR IEINS1
IECLOCK LD A,#02:JR IEINS1
IEINS   LD A,#80
IEINS1  XOR C:LD (KEYSTAT),A
        CALL PRMODES
IERET   RET

IECLR   LD HL,BUFED,BC,81'+#20
IECLR1  LD (HL),C:INC L:DJNZ IECLR1
        LD A,(IEXMIN)
IEPXCH  CALL IESETCH
IESETPX LD (IEPX),A,E,A:RET

IELFT   LD A,E
IEXMIN  EQU $+1:CP 0:RET Z
        DEC A:JR IESETPX

IERGT   LD A,E
IERGT1
IEXMAX  EQU $+1:CP 0:RET Z
        INC A:JR IESETPX

IEHOM   LD A,(IEXMIN):JR IESETPX

IEEND   LD HL,BUFED+81
        LD A,(IEXMIN),B,A,C,#20
IEEND1  DEC L:LD A,L:CP B:JR Z,IEEND2
        LD A,(HL):CP C:JR Z,IEEND1
IEEND2  LD A,(IEXMAX)
        CP L:JR C,IESETPX
        LD A,L:JR IESETPX

IEBSP   CALL IESETCH
        LD A,(IEXMIN):CP E
        LD A,9:JR Z,IEEXIT
        CALL IELFT:INC E:LD D,BUFED[
IEBSP1  BIT 7,C:JR Z,IEBSP2
        LD HL,DE:INC L
        LD A,81:SUB L
        LD C,A,B,0:LDIR
IEBSP2  LD A,#20:LD (DE),A:RET

IEDEL   CALL IESETCH
        INC E:LD D,BUFED[
        LD A,81:SUB E:LD B,A
        LD HL,DE,A,#20
IEDEL1  CP (HL):JR NZ,IEBSP1
        INC L:DJNZ IEDEL1
        LD A,12
IEEXIT  POP HL:RET

IEBSPW
IELFTW
IERGTW
IEDELW  RET

WTKEY1  CALL CUR
IEPROC  EQU $+1:CALL 0
        LD HL,IERET,(IEPROC),HL
WTKEY   CALL INKEY:JR Z,WTKEY1:RET

INKEY   EI:HALT
INKEY1  LD HL,KEYSTAT
        BIT 0,(HL):RET Z
        RES 0,(HL):LD C,(HL):RET

CUR     LD A,(SYST):BIT 0,A:RET Z
        LD DE,(CURFLSH)
        LD HL,CNTCUR:LD A,(HL)
        CP E:PUSH AF
        INC A:CP D:JR C,$+3:XOR A
        LD (HL),A:POP AF
        JR CUROUT

CURON   PUSH AF,HL
        LD A,(SYST):BIT 0,A
        CALL NZ,CUROFF
        POP HL,AF
        CALL CRDCUR
        XOR A:LD (CNTCUR),A
        SCF:CALL CUROUT
        LD HL,SYST:SET 0,(HL):RET

CUROFF  LD HL,SYST:RES 0,(HL)
CUROFF1 XOR A
CUROUT  LD D,0:JR NC,$+3:DEC D
MCUR    EQU $+1:LD BC,0
ACUR    EQU $+1:LD HL,0
_LD A,(HL):XOR D:AND B:XOR D:LD (HL),A
        INC L
_LD A,(HL):XOR D:AND C:XOR D:LD (HL),A
        RET

;H-Y L-X A-BASEX
CRDCUR  LD B,A
        LD A,H:CALL CRDA
        LD A,E:OR B:LD E,A:EX DE,HL
        LD A,E:ADD A,A,A,E:LD C,A
        RRCA:RRCA
        AND #1F:ADD A,L:LD L,A
        LD A,H:OR 7:LD H,A
        LD A,C:AND 3:LD B,A
        LD A,3:LD E,#FF:JR Z,CRDCUR2
        SCF
CRDCUR1 RRA:RR E:RRA:RR E:DJNZ CRDCUR1
CRDCUR2 LD D,A
        LD (ACUR),HL,(MCUR),DE:RET

CRDA    LD D,A:RRCA:RRCA:RRCA
        AND #E0:LD E,A
        LD A,D:AND #18:OR #40:LD D,A
        RET

PRLN    LD A,(IEXMAX)
        INC A:LD L,A,H,BUFED[
        LD A,81:SUB L:LD B,A:XOR A
PRLN1   OR (HL):INC L:DJNZ PRLN1
        LD HL,SYST:RES 2,(HL)
        CP #20:JR Z,PRLN2:SET 2,(HL)
PRLN2   LD A,(IEXMAX),C,A
        LD A,(IEXMIN),B,A
        LD A,(IEPY):CALL CRDA
        LD A,(BASEX):OR E:LD E,A
        INC D
        LD A,C:SUB B
        PUSH AF,DE:RRA:SRL A
        LD HL,BUFED+1:CALL PR4L
        POP HL
        LD A,H:RRA:RRA:RRA
        AND #03:OR #58:LD H,A
        POP AF:PUSH AF
        LD B,A:ADD A,A,A,B:RRA:SRL A
        LD B,A,A,(BUFED)
        BIT 7,A:LD A,(COLNOM)
        JR Z,$+4:LD A,(COLM)
PRLN3   LD (HL),A:INC L:DJNZ PRLN3
        POP AF:AND 3:INC A:LD LY,A,HY,D
        LD H,FONT[+#12,B,FONT[
        LD C,(IX+0)
        LD L,(IX+1):SCF:CALL PRLN5
        LD C,(IX+2):OR A:CALL PRLN5
        LD L,(IX+3):SCF

PRLN5   DEC LY:INC LY:RET Z
        DEC LY:JR NZ,PRLN6
        LD A,(SYST):BIT 2,A
        LD L," ",C,L:JR Z,$+4:LD C,#1F
        JR C,PRLN6
        LD L,C,C," "
PRLN6   LD A,(IEPY):SUB HGT+1:JP NC,PR4B
        LD A,E:OR #E0:INC A:JP NZ,PR4B
        LD HY,6
PRLN7   LD A,(BC):OR (HL):INC A
        LD (DE),A:INC H,D,B
        DEC HY:JR NZ,PRLN7
        RET

;***************************************
;INIT SCROLLER AND FONT
DEPACK  LD A,27:CALL SETBANK
        LD DE,#C000,HL,#C600
        LD IX,#CC00,IY,#D200
        LD B,E:EXX
        LD HL,FONT,DE,#D800
        LD B,6
ISC     LD A,(HL):INC L
        RRCA:RRCA
        LD (DE),A:INC E
        EXX:LD C,B
        RRA:RR C:RRA:RR C
        LD (DE),A:INC E
        LD (HL),C:INC L
        RRA:RR C:RRA:RR C
        LD (IX),A:INC LX
        LD (IY),C:INC LY
        EXX:JR NZ,ISC
        INC H,D,HX,HY
        EXX:INC H,D:EXX
        DJNZ ISC

        LD HL,SCR,A,HGT,DE,#11D5
        LD IX,BUFSADR
ISC1    LD (IX),L,(IX+1),H
        LD (IX+HGT*2),L:INC IX
        LD (IX+HGT*2),H:INC IX
        LD (HL),#61:INC HL
        LD (HL),#6F:INC HL
        LD C,6
ISC2    LD (HL),#F9:INC HL
        LD (HL),#24:INC HL
        LD B,15
ISC2A   LD (HL),D:INC HL,HL,HL
        LD (HL),E:INC HL
        DJNZ ISC2A
        DEC C:JR NZ,ISC2
        LD (HL),#1E:INC HL,HL
        LD (HL),#FD:INC HL
        LD (HL),#E9:INC HL
        DEC A:JR NZ,ISC1

        LD (PR8ST),HL
        PUSH HL
        LD (HL),#D9:INC HL
        LD IX,TBLPRN
        LD C,2
ISC3    LD (HL),#26:INC HL
        LD (HL),FONT[+#12:INC HL
        LD (HL),#16:INC HL
        LD (HL),FONT[:INC HL
        LD (HL),#C1:INC HL
        LD (HL),#68:INC HL
        LD (HL),#59:INC HL
        CALL ISC4
        LD (HL),#C1:INC HL
        LD (HL),#59:INC HL
        CALL ISC4
        LD (HL),#68:INC HL
        CALL ISC4
        DEC HL,HL,C:JR NZ,ISC3
        LD (HL),#D9:INC HL
        LD (HL),#DD:INC HL
        LD (HL),#19:INC HL
        LD (HL),#FD:INC HL
        LD (HL),#19:INC HL
        LD (HL),#05:INC HL
        LD (HL),#C2:INC HL
        POP DE
        LD (HL),E:INC HL
        LD (HL),D:INC HL
        LD (HL),#F9:INC HL
        LD (HL),#C9:RET

ISC4    LD D,#DD:CALL ISC5
        LD D,#FD:CALL ISC5
        INC IX:RET

ISC5    LD A,(IX):LD B,3
ISC6    LD (HL),#1A:INC HL
        LD (HL),#B6:INC HL
        LD (HL),D:INC HL
        LD (HL),#77:INC HL
        LD (HL),A:INC HL
        LD (HL),#14:INC HL
        LD (HL),#24:INC HL
        ADD A,62:DJNZ ISC6:RET

TBLPRN  DB -64,-63,-68,-67,-72,-71

;***************************************

KEY     XOR A:LD (REPKEY),A
        LD D,TBKBIT[,HL,TBMKEY
        LD BC,#FEFE:LD HX,#FF
KEY0    IN A,(C):OR (HL):INC L
        LD E,A,A,(DE)
        OR A:JR Z,KEY1:RET M
        ADD A,(HL),A,HX:RET NC:LD HX,A
KEY1    INC L:RLC B:JR C,KEY0
        LD D,HX:INC D:JR Z,$+3:DEC D
        IN A,(C):RRC B:IN E,(C)
        RRA:JR C,$+4:SET 7,D
        BIT 1,E:JR NZ,$+4:SET 6,D
;CS=SET7 SS=SET6
        LD HL,RAWKEY,B,(HL),(HL),D,C,D
        LD HL,KEYBUF,DE,KEYBUF+4
        BIT 7,(HL):JR NZ,KEY2
        INC HL:DEC (HL):DEC HL
        JR NZ,KEY2:LD (HL),#FF
KEY2    EX DE,HL
        BIT 7,(HL):JR NZ,KEY3
        INC HL:DEC (HL):DEC HL
        JR NZ,KEY3:LD (HL),#FF
KEY3    LD A,C:AND #3F:JR NZ,KEY3A
        LD A,B:AND C:OR #3F:INC A:RET NZ
        LD A,#3F,C,A
KEY3A   CP (HL):JR Z,KEY6
        EX DE,HL:CP (HL):JR Z,KEY6
        BIT 7,(HL):JR NZ,KEY4
        EX DE,HL:BIT 7,(HL):RET Z
KEY4    LD (HL),A:INC L:LD (HL),5:INC L
        LD A,(REPDEL),(HL),A:INC L
        LD A,(KEYSTAT),B,A
        PUSH HL:CALL KEYRCD:POP HL
        LD (HL),A
KEY5    LD (LASTK),A
        LD HL,KEYSTAT:SET 0,(HL):RET

KEY6    INC L:LD (HL),5
        INC L:DEC (HL):RET NZ
        LD A,(REPPER),(REPKEY),A
        LD (HL),A:INC L
        LD A,(HL):JR KEY5

;KEYSTAT 0 =1 KEY PRESSED
;        1 =1 CAPS LOCK
;        2 =1 RUS
;        3 =1 GRAPH
;        4 =1 ONLY LAT;CS OR SS-BIG/SML
;             NUMBERS: MDF, SEE INSIDE
;        5 =1 RES
;        6 =1 
;        7 =1 INS

KEYRCD  LD A,C:CP #3F:JR Z,KEYR2A
        AND #3F:ADD A,TBKEY0]
        LD L,A,H,TBKEY0[:LD A,(HL)
        CP #41:JR NC,KEYR3
        LD E,A,A,C:AND #C0:LD A,E:RET Z
        BIT 4,B:JR Z,KEYR00
        BIT 6,C:JR Z,KEYR00:SET 7,C
KEYR00  CP #0D:LD D,#3A:JR Z,KEYR0
        CP #20:LD D,#3B:JR NZ,KEYR1
KEYR0   LD A,D
KEYR1   SUB #30:LD HL,TBKEY1-12
        BIT 6,C:JR Z,$+4:ADD A,12
        BIT 7,C:JR Z,KEYR2:ADD A,24
KEYR2   ADD A,L:LD L,A,A,(HL):RET

KEYR2A  LD A,#0E:RET

KEYR3   LD E,A:SUB #41:LD D,A
        LD A,C:OR #3F:INC A
        JR NZ,$+4:RES 6,C
        BIT 4,B:JR NZ,KEYR4B; IGNORE
        BIT 3,B:JR Z,KEYR4; NO GRAPH
        BIT 6,C:JR NZ,KEYR4A; GRAPH/SS
        LD A,D:LD HL,TBKEY2
        BIT 7,C:JR Z,KEYR2; GRAPH
        ADD A,26:JR KEYR2; GRAPH/CS

KEYR4   BIT 2,B:JR NZ,KEYR8; RUS
        BIT 6,C:JR Z,KEYR5; LAT
KEYR4A  LD A,D,HL,TBKEY3:JR KEYR2;LAT/SS

KEYR4B  LD A,C:AND #C0:LD A,E
        JR NZ,KEYR7:RET

KEYR5   LD A,B:RRCA:RRCA:XOR C
        RRCA:RRCA:AND #20:XOR E
KEYR7   XOR #20:RET

KEYR8   LD A,D:BIT 6,C:JR Z,KEYR9; RUS
        LD HL,TBKEY5; RUS/SS
        LD A,D:ADD A,L:LD L,A,A,(HL)
        CP 7:RET NC:ADD A,26
KEYR9   LD HL,TBKEY4:ADD A,L
        BIT 6,B:JR Z,$+4:ADD A,33
        LD L,A,D,(HL)
        LD E,0:CALL KEYR5
        LD A,D:RET Z
        INC A:CP #F1:RET Z:DEC A
        ADD A,#20:CP #B0:RET C
        ADD A,#30:RET

;***************************************

PLN     XOR A:LD B,A,C,A,HL,BUFED+1:CPIR
        DEC L
PLN1    LD A,L:CP 1:JR Z,PLN2
        DEC L:LD A,(HL):CP " ":JR Z,PLN1
        INC L
PLN2    LD DE,BUFPC
        LD A,L:DEC A:JR Z,PLN3
        CP #29:CCF:RET C
        LD C,A,B,0,HL,BUFED+1
        LDIR:LD C,A
        XOR A:LD (DE),A:INC DE
        LD A,C:INC A
PLN3    LD C,A,A,(BUFED)
        AND #80:OR C:LD (DE),A:INC DE
        LD A,C:INC A:OR A:RET

DLN     LD HL,BUFDPC+1
        LD A,(IX)
        OR A:JR Z,DLN2
        CP #80:JR Z,DLN2
        INC IX
DLN1    LD (HL),A:INC L:RET Z
        LD A,(IX):INC IX
        OR A:JR NZ,DLN1
DLN2    LD (HL)," ":INC L:JR NZ,DLN2
        LD A,(IX):INC IX
        LD (BUFDPC),A
        XOR A:INC A:RET

DLNA    PUSH HL:POP IX
        CALL DLN
        PUSH IX:POP HL
        RET NZ:JP GERR

;***************************************

BLITSC0 EI:HALT
BLITSCR DI:CALL SBDCR:LD (BLSCRSP),SP
        LD HL,#583F,BC,32,DE,2:EXX
        LD A,(BEGSCR):ADD A,A,A,BUFSADR]
        LD LX,A,HX,BUFSADR[
        LD (IX+HGT*2+0),EBLSCR]
        LD (IX+HGT*2+1),EBLSCR[
        LD (EBLSCR+1),IX
        LD A,#3F,BC,#2041
        LD IY,BLSCR3:LD SP,IX:RET

BLSCR3  EXX:LD SP,HL:ADD HL,BC,IX,DE:EXX
        LD D,E
.15     PUSH DE
        LD SP,IX:ADD A,B:RET NC
        INC H,H:LD C,H:RET

EBLSCR  LD SP,0:POP DE
        LD HL,HGT*2:ADD HL,SP:LD SP,HL
        PUSH DE
BLSCRSP EQU $+1:LD SP,0
        JP RESTBNK

;***************************************

PRBUF0  LD A,(TPY)
PRBUF   LD HL,BUFDPC
;PRINT 40 SYMBS A=(PY) HL=LINEPTR
;FIRST BYTE=COLOR
PRBUF8  DEC A:RET M:EX DE,HL
        LD H,A
        CALL SBDCR
        LD A,(BEGSCR):ADD A,H,A,A
        ADD A,BUFSADR]:LD L,A,H,BUFSADR[
        LD A,(HL):INC L:LD H,(HL),L,A
        LD BC,62*2+1:ADD HL,BC
        PUSH HL:POP IX
        LD C,62*3:ADD HL,BC
        PUSH HL:POP IY
        LD A,(DE):INC DE
        BIT 7,A:LD A,(COLNOM)
        JR Z,$+5:LD A,(COLM)
        LD (IY+64),A
        LD HL,RESTBNK:PUSH HL
        LD HL,0:ADD HL,SP
        EX DE,HL:LD SP,HL:EX DE,HL
        LD DE,-12,B,5
PR8ST   EQU $+1:JP 0

;***************************************

TBSTAT  DB #04,0,"LAT"
        DB #02,3,"smlBIG"
        DB #80,6,"OVRINS"
        DB #20,9,"SETRES"
        DB #FF

STRMVER DB "Storm2.0    "

;***************************************

INISTAT LD DE,#400D
        LD HL,"Li",BC,"ne":CALL PR4R
        LD L,":":CALL PR1LS
        LD DE,#4015
        LD HL,"Co",BC,"l:":CALL PR4R
        LD DE,#401A
        LD HL," F",BC,"r:":JP PR4R

PRMODES LD HL,TBSTAT
PMD1    LD A,(HL):INC A:RET Z
        LD A,(KEYSTAT)
        AND (HL) :INC HL
        LD C,(HL):INC HL
        PUSH HL:JR Z,PMD2
        LD DE,3:ADD HL,DE
PMD2    LD D,(HL):INC HL
        LD E,(HL):INC HL
        LD B,(HL):EX DE,HL
        LD E,C,C,#20,D,#40
        CALL PR4R
        POP HL:LD BC,6:ADD HL,BC:JR PMD1

PRNLNB  CALL SBDCR
PRNLINE LD HL,(NLINE):CALL CORSIZE
PRNLN2  LD DE,#4011
PRNLN3  JR PR4R

PRCOL   LD A,(IEPX)
PRCOL1  CALL CRDB
        PUSH BC:LD DE,#4018:CALL PR1RS
        POP BC:LD L,B:JR PR1LS

PRCHANG LD A,27:CALL SETBANK
        LD HL," M",BC,"df"
        LD DE,#52EB:JR PR4R

PRFREE  XOR A:CALL SETBANK
        LD HL,#C100,B,L
PRFR1   LD A,(HL):INC A:JR NZ,$+3:INC B
        INC L:JR NZ,PRFR1
        LD L,B,H,0:LD A,27:CALL SETBANK
        CALL CORSIZE
        LD DE,#20'+"k"
        LD A,B:CP D:JR Z,PRFR3
        LD C,E
PRFR2   LD DE,#4020-3:JR PR4R

PRFR3   LD A,L:CP D:JR Z,PRFR4
        LD B,E:JR PRFR2

PRFR4   LD L,E:JR PRFR2

; "L" TO DE; LEFT OF 4
PR1LS   LD HY,D,H,FONT[,B,H,C,32:JR PR4B

; "L" TO DE; RIGHT OF 4
PR1RS   LD HY,D,H,FONT[+#1E,B,H,C,32
        JR PR4B

;PRINT "HLBC",TO DE
PR4R    LD HY,D
        LD A,B:LD (P4R1+1),A
        LD A,C:LD (P4R2+1),A
        LD C,H,H,FONT[+#12,B,FONT[
        CALL PR4B
P4R1    LD C,0:CALL PR4B
P4R2    LD L,0
PR4B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,E,B
        LD D,HY:RET

PRDOWNL LD HL,STRMVER,DE,#52E0
        LD A,3:CALL PR4L
        LD HL,WORKBUF:PUSH HL
        LD BC,32'+" "
PRDWL1  LD (HL),C:INC L:DJNZ PRDWL1
        POP HL:PUSH HL
        LD A,(NBLOCKS):OR A
        JR Z,PRDWL4
        LD D," "
        CP 1:JR Z,PRDWL3
        CP 10:JR C,PRDWL2
        LD A,"^"-"0"
PRDWL2  ADD A,"0":LD D,A
PRDWL3  LD (HL),D : INC L
        LD (HL),"B":INC L
        LD (HL),"l":INC L
        LD (HL),"k"
PRDWL4  LD L,5
        PUSH HL:CALL DESCTX
        EX DE,HL:POP HL
        LD A,(DE):PUSH DE
        BIT 2,A
        JR Z,PRDWL5
        LD (HL),"M":INC L
        LD (HL),"d":INC L
        LD (HL),"f"
PRDWL5  LD L,9,C,#30
        LD A,(NUMTEXT):LD D,A
        ADD A,C
        LD (HL),A:INC L
        LD (HL),"/":INC L
        LD A,(NOFTEXT):ADD A,C
        LD (HL),A:INC L
        LD L,13
        LD (HL),"E":INC L
        LD (HL),"d":INC L
        LD (HL),":":INC L
        POP DE:PUSH DE,HL:EX DE,HL
        LD A,L:ADD A,9:LD L,A
        LD E,(HL):INC L:LD D,(HL)
        EX DE,HL:CALL CORSIZE
        EX DE,HL:POP HL
        LD (HL),D:INC L
        LD (HL),E:INC L
        LD (HL),B:INC L
        LD (HL),C
        LD L,22:POP DE
        LD A,(DE):INC E
        AND 3:ADD A,"A"
        LD (HL),A:INC L
        LD (HL),":":INC L
        EX DE,HL:LD BC,8:LDIR
        LD A,27:CALL SETBANK
        POP HL:LD DE,#52E8,A,8
;HL=TEXT> TO DE  A=SIZE
PR4L    PUSH HL:POP IX
        LD LY,A:LD HY,D
PR4A    LD H,FONT[+#12,B,FONT[
        LD C,(IX+0)
        LD L,(IX+1):CALL PR4B
        LD C,(IX+2):CALL PR4B
        LD L,(IX+3):CALL PR4B
        LD BC,4:ADD IX,BC
        DEC LY:JR NZ,PR4A
        RET

;A=BYTE > "LB" C=#20
CRDB    LD L,A:XOR A
        LD BC,#0820,DE,#300F
        RL L:ADC A,A:DAA:DJNZ $-4
        LD B,A:AND #F0:JR NZ,CDB1
        LD A,B:AND E:ADD A,D
        LD L,A,B,C:RET

CDB1    RRCA:RRCA:RRCA:RRCA
        ADD A,D:LD L,A
        LD A,B:AND E:ADD A,D:LD B,A
        RET

;HL=WORD > "HLBC"
CRDW    CALL WTOBCD
        LD BC,#2020:LD L,C
        LD A,E:AND #0F:ADD A,#30:LD H,A
        LD A,E:RRA:RRA:RRA:RRA:AND #0F
        LD E,A:OR D:RET Z
        LD A,E:LD E,#30:ADD A,E
        LD L,H,H,A
        LD A,D:OR A:RET Z
        AND #0F:ADD A,E
        LD B,L,L,H,H,A
        LD A,D:RRA:RRA:RRA:RRA:AND #0F
        RET Z:ADD A,E
        LD C,B,B,L,L,H,H,A
        RET

; HL [0..9999] TO DE [BCD];   332
WTOBCD  LD D,0:LD A,H:RRCA:RRCA
        LD H,A:AND #0F:OR A:DAA
.2      RL H:ADC A,A:DAA
        RL L:ADC A,A:DAA
.3      RL L:ADC A,A:DAA:RL D
.4      RL L:ADC A,A:DAA
        LD E,A:LD A,L
.4      RRA
        LD L,A:LD A,D
.4      RL L:ADC A,A:DAA
        LD D,A:RET

CORSIZE LD DE,10000
        OR A:SBC HL,DE:JR C,CORSZ2
        LD B,"A"-"0"-1
CORSZ1  INC B:SBC HL,DE:JR NC,CORSZ1
        ADD HL,DE:PUSH BC:CALL WTOBCD
        LD C,#30
        LD A,D:RRA:RRA:RRA:RRA
        AND #0F:ADD A,C:LD H,A
        LD A,D:AND #0F:ADD A,C:LD L,A
        LD A,E:RRA:RRA:RRA:RRA
        AND #0F:ADD A,C:LD B,A
        LD A,E:AND #0F:ADD A,C:LD C,A
        POP DE:LD A,H:ADD A,D:LD H,A
        RET

CORSZ2  ADD HL,DE:JP CRDW

