;***************************************
;UNI EDITOR EXIT: A-OUT_OF_LINE CODE
;B-PY C-X(BYTE) D-XMIN E-XMAX
;CF=1 CALL END_OF_LINE
;CF=0 A=PX
;CONTINUE=CALL IEDCONT

IED     PUSH AF
        LD (IEPX),A
        LD A,D,(IEXMIN),A
        LD A,E,(IEXMAX),A
        LD A,B,(IEPY),A
        CALL CRDA:LD A,E:OR C:LD E,A
        LD (IESCR),DE
        POP AF:CALL C,IEEND
        OR A:CALL IECOPY
        EI:HALT
IEDCONT CALL IED0
        LD HL,SYST
        BIT 2,(HL):RES 2,(HL)
        PUSH AF:CALL NZ,PRLN2:POP AF
        RET

IEDB    LD A,1
IEDO    OUT (#FE)
IED0    CALL CURON
        CALL PRLN
;        LD A,(IEPY):CP HGT+1
;        DI:CALL C,PRBUF:EI
        CALL WTKEY
        XOR A:OUT (#FE),A
LASTK   EQU $+1:LD A,0:CP #20:JR C,IED2
        CALL IESETCH
        LD HL,(IEPX),H,BUFED[:INC L
        BIT 7,C:JR Z,IED1
        LD B,A
        LD A,(BUFED+80):CP 32:JR NZ,IEDB
        LD A,80:SUB L:LD C,A
        LD A,B:LD B,0
        LD HL,BUFED+79,DE,BUFED+80
        LDDR:EX DE,HL
IED1    LD (HL),A
        LD A,(IEPX):CALL IERGT1:JR IED0

IED2    ADD A,A:ADD A,IEDTBL]:LD L,A
        ADC A,IEDTBL[:SUB L:LD H,A
        LD A,(HL):INC HL
        LD H,(HL):LD L,A
        LD A,H:OR A:LD A,L:RET Z;OUTLINE
        LD DE,IED0:PUSH DE
        LD DE,(IEPX):JP (HL)

IEDTBL  DW 0,1,IECLR,2,3,4,5,6,IELFT
        DW IERGT,7,8,IEBSP,10,11,IEDEL
        DW IEBSPW,IERLAT,IECLOCK,13,14
        DW IELFTW,15,16,IERGTW,IEDELW
        DW IEOLD,IEHOM,IEINS,IEEND
        DW IERET,IERET

IESETCH PUSH AF:LD A,(SYST)
        RES 1,A:LD (SYST),A:POP AF:RET

IERLAT  LD A,#04:JR IEINS1
IECLOCK LD A,#02:JR IEINS1
IEINS   LD A,#80
IEINS1  XOR C:LD (KEYSTAT),A
IERET   RET

IECLR   OR A:CALL IECOPY
        LD HL,BUFED,BC,81'+#20
IECLR1  LD (HL),C:INC L:DJNZ IECLR1
        LD A,(IEXMIN)
IEPXCH  CALL IESETCH
IESETPX LD (IEPX),A,E,A:RET

IEOLD   SCF:CALL IECOPY,IESETCH:RET

IELFT   LD A,E
IEXMIN  EQU $+1:CP 0:RET Z
        DEC A:JR IESETPX

IERGT   LD A,E
IERGT1
IEXMAX  EQU $+1:CP 0:RET Z
        INC A:JR IESETPX

IEHOM   LD A,(IEXMIN):JR IESETPX

IEEND   LD HL,BUFED+81
        LD A,(IEXMIN),B,A,C,#20
IEEND1  DEC L:LD A,L:CP B:JR Z,IEEND2
        LD A,(HL):CP C:JR Z,IEEND1
IEEND2  LD A,(IEXMAX)
        CP L:JR C,IESETPX
        LD A,L:JR IESETPX

IEBSP   CALL IESETCH
        LD A,(IEXMIN):CP E
        LD A,9:JR Z,IEEXIT
        CALL IELFT:INC E:LD D,BUFED[
IEBSP1  BIT 7,C:JR Z,IEBSP2
        LD HL,DE:INC L
        LD A,81:SUB L
        LD C,A,B,0:LDIR
IEBSP2  LD A,#20:LD (DE),A:RET

IEDEL   CALL IESETCH
        INC E:LD D,BUFED[
        LD A,81:SUB E:LD B,A
        LD HL,DE,A,#20
IEDEL1  CP (HL):JR NZ,IEBSP1
        INC L:DJNZ IEDEL1
        LD A,12
IEEXIT  POP HL:RET

IECOPY  LD HL,BUFED,DE,BUFOLD,BC,81
        JR NC,$+3:EX DE,HL:LDIR:RET

IEBSPW
IELFTW
IERGTW
IEDELW  RET

WTKEY   LD HL,KEYSTAT
WTKEY1  EI:HALT:BIT 0,(HL):JR Z,WTKEY1
        RES 0,(HL):LD C,(HL):RET

;GET ADR OF SCR LINE (#A)
CRDA    LD D,A:RRCA:RRCA:RRCA
        AND #E0:LD E,A
        LD A,D:AND #18:OR #40:LD D,A
        RET

CUR     LD A,(SYST):BIT 0,A:RET Z
        LD DE,CURFLSH
        LD HL,CNTCUR:LD A,(HL)
        CP E:PUSH AF
        INC A:CP D:JR C,$+3:XOR A
        LD (HL),A:POP AF
        JR CUROUT

CURON   LD HL,SYST:BIT 0,(HL):RES 0,(HL)
        PUSH HL
        CALL NZ,CUROFF1
        CALL CRDCUR
        XOR A:LD (CNTCUR),A
        SCF:CALL CUROUT
        POP HL:SET 0,(HL):RET

CUROFF  LD HL,SYST:RES 0,(HL)
CUROFF1 XOR A
CUROUT  LD D,0:JR NC,$+3:DEC D
MCUR    EQU $+1:LD BC,0
ACUR    EQU $+1:LD HL,0
_LD A,(HL):XOR D:AND B:XOR D:LD (HL),A
        INC L
_LD A,(HL):XOR D:AND C:XOR D:LD (HL),A
        RET

CRDCUR  LD HL,(IESCR),A,(IEPX)
        LD E,A:ADD A,A,A,E:LD C,A
        RRCA:RRCA
        AND #1F:ADD A,L:LD L,A
        LD A,H:OR 7:LD H,A
        LD A,C:AND 3:LD B,A
        LD A,3:LD E,#FF:JR Z,CRDCUR2
        SCF
CRDCUR1 RRA:RR E:RRA:RR E:DJNZ CRDCUR1
CRDCUR2 LD D,A
        LD (ACUR),HL,(MCUR),DE:RET

PRLN    LD A,(IEXMAX)
        INC A:LD L,A,H,BUFED[
        LD A,81:SUB L:LD B,A:XOR A
PRLN1   OR (HL):INC L:DJNZ PRLN1
        LD HL,SYST:RES 2,(HL)
        CP #20:JR Z,PRLN2:SET 2,(HL)
PRLN2   LD A,(IEXMAX),C,A
        LD A,(IEXMIN),B,A
IESCR   EQU $+1:LD DE,0:INC D
        LD A,C:SUB B
        PUSH AF,DE:RRA:SRL A
        LD HL,BUFED+1:CALL PR4L
        POP HL
        LD A,H:RRA:RRA:RRA
        AND #03:OR #58:LD H,A
        POP AF:PUSH AF
        LD B,A:ADD A,A,A,B:RRA:SRL A
        LD B,A,A,(BUFED)
        BIT MARKBIT,A:LD A,COLNOM
        JR Z,$+4:LD A,COLM
PRLN3   LD (HL),A:INC L:DJNZ PRLN3
        POP AF:AND 3:INC A:LD LY,A,HY,D
        LD H,FONT[+#12,B,FONT[
        LD C,(IX+0)
        LD L,(IX+1):SCF:CALL PRLN5
        LD C,(IX+2):OR A:CALL PRLN5
        LD L,(IX+3):SCF

PRLN5   DEC LY:INC LY:RET Z
        DEC LY:JR NZ,PRLN6
        LD A,(SYST):BIT 2,A
        LD L," ",C,L:JR Z,$+4:LD C,#1F
        JR C,PRLN6
        LD L,C,C," "
PRLN6   LD A,(IEPY):SUB HGT+1:JP NC,PR4B
        LD A,E:OR #E0:INC A:JP NZ,PR4B
        LD HY,6
PRLN7   LD A,(BC):OR (HL):INC A
        LD (DE),A:INC H,D,B
        DEC HY:JR NZ,PRLN7
        RET

PR4B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,D,B
_LD A,(BC):OR (HL):LD (DE),A:INC H,E,B
        LD D,HY
        RET

;HL=TEXT> TO DE  A=SIZE
PR4L    PUSH HL:POP IX
        LD LY,A:LD HY,D
PR4A    LD H,FONT[+#12,B,FONT[
        LD C,(IX+0)
        LD L,(IX+1):CALL PR4B
        LD C,(IX+2):CALL PR4B
        LD L,(IX+3):CALL PR4B
        LD BC,4:ADD IX,BC
        DEC LY:JR NZ,PR4A
        RET

;***************************************

SETINT  LD HL,INT,A,H,I,A:IM 2:INC A
        LD (HL),A:INC L:JR NZ,$-2
        INC H:LD (HL),A,L,H
        LD (HL),#C9:INC L
        LD (HL),INTSRV]:INC L
        LD (HL),INTSRV[
        RET

SINT    LD A,#C3:JR $+4
RINT    LD A,#C9
        LD (INT+INT[+#0101),A
        RET

INTSRV  PUSH AF,HL,DE,BC,IX,IY
        CALL KEY,CUR
        POP IY,IX,BC,DE,HL,AF
        EI:RET

;***************************************
;INIT SCROLLER AND FONT
DEPACK  LD DE,#C000,HL,#C600
        LD IX,#CC00,IY,#D200
        LD B,E:EXX
        LD HL,FONT,DE,#D800
        LD B,6
ISC     LD A,(HL):INC L
        RRCA:RRCA
        LD (DE),A:INC E
        EXX:LD C,B
        RRA:RR C:RRA:RR C
        LD (DE),A:INC E
        LD (HL),C:INC L
        RRA:RR C:RRA:RR C
        LD (IX),A:INC LX
        LD (IY),C:INC LY
        EXX:JR NZ,ISC
        INC H,D,HX,HY
        EXX:INC H,D:EXX
        DJNZ ISC
        RET

;***************************************

KEY     LD D,TBKBIT[,HL,TBMKEY
        LD BC,#FEFE:LD HX,#FF
KEY0    IN A,(C):OR (HL):INC L
        LD E,A,A,(DE)
        OR A:JR Z,KEY1:RET M
        ADD A,(HL),A,HX:RET NC:LD HX,A
KEY1    INC L:RLC B:JR C,KEY0
        LD D,HX:INC D:JR Z,$+3:DEC D
        IN A,(C):RRC B:IN E,(C)
        RRA:JR C,$+4:SET 7,D
        BIT 1,E:JR NZ,$+4:SET 6,D
;CS=SET7 SS=SET6
        LD HL,RAWKEY,B,(HL),(HL),D,C,D
        LD HL,KEYBUF,DE,KEYBUF+4
        BIT 7,(HL):JR NZ,KEY2
        INC HL:DEC (HL):DEC HL
        JR NZ,KEY2:LD (HL),#FF
KEY2    EX DE,HL
        BIT 7,(HL):JR NZ,KEY3
        INC HL:DEC (HL):DEC HL
        JR NZ,KEY3:LD (HL),#FF
KEY3    LD A,C:AND #3F:JR NZ,KEY3A
        LD A,B:AND C:OR #3F:INC A:RET NZ
        LD A,#3F,C,A
KEY3A   CP (HL):JR Z,KEY6
        EX DE,HL:CP (HL):JR Z,KEY6
        BIT 7,(HL):JR NZ,KEY4
        EX DE,HL:BIT 7,(HL):RET Z
KEY4    LD (HL),A:INC L:LD (HL),5:INC L
REPDEL  EQU $+1:LD (HL),10:INC L
KEYSTAT EQU $+1:LD B,%10000010
        PUSH HL:CALL KEYRCD:POP HL
        LD (HL),A
KEY5    LD (LASTK),A
        LD HL,KEYSTAT:SET 0,(HL):RET

KEY6    INC L:LD (HL),5
        INC L:DEC (HL):RET NZ
REPPER  EQU $+1:LD (HL),1:INC L
        LD A,(HL):JR KEY5

;KEYSTAT 0 =1 KEY PRESSED
;        1 =1 CAPS LOCK
;        2 =1 RUS
;        3 =1 GRAPH
;        4 =1 ONLY LAT;CS OR SS-BIG/SML
;             NUMBERS: MDF, SEE INSIDE
;        5 =1 RES
;        6 =1 
;        7 =1 INS

KEYRCD  LD A,C:CP #3F:JR Z,KEYR2A
        AND #3F:ADD A,TBKEY0]
        LD L,A,H,TBKEY0[:LD A,(HL)
        CP #41:JR NC,KEYR3
        LD E,A,A,C:AND #C0:LD A,E:RET Z
        BIT 4,B:JR Z,KEYR00
        BIT 6,C:JR Z,KEYR00:SET 7,C
KEYR00  CP #0D:LD D,#3A:JR Z,KEYR0
        CP #20:LD D,#3B:JR NZ,KEYR1
KEYR0   LD A,D
KEYR1   SUB #30:LD HL,TBKEY1-12
        BIT 6,C:JR Z,$+4:ADD A,12
        BIT 7,C:JR Z,KEYR2:ADD A,24
KEYR2   ADD A,L:LD L,A,A,(HL):RET

KEYR2A  LD A,#0E:RET

KEYR3   LD E,A:SUB #41:LD D,A
        LD A,C:OR #3F:INC A
        JR NZ,$+4:RES 6,C
        BIT 4,B:JR NZ,KEYR4B; IGNORE
        BIT 3,B:JR Z,KEYR4; NO GRAPH
        BIT 6,C:JR NZ,KEYR4A; GRAPH/SS
        LD A,D:LD HL,TBKEY2
        BIT 7,C:JR Z,KEYR2; GRAPH
        ADD A,26:JR KEYR2; GRAPH/CS

KEYR4   BIT 2,B:JR NZ,KEYR8; RUS
        BIT 6,C:JR Z,KEYR5; LAT
KEYR4A  LD A,D,HL,TBKEY3:JR KEYR2;LAT/SS

KEYR4B  LD A,C:AND #C0:LD A,E
        JR NZ,KEYR7:RET

KEYR5   LD A,B:RRCA:RRCA:XOR C
        RRCA:RRCA:AND #20:XOR E
KEYR7   XOR #20:RET

KEYR8   LD A,D:BIT 6,C:JR Z,KEYR9; RUS
        LD HL,TBKEY5; RUS/SS
        LD A,D:ADD A,L:LD L,A,A,(HL)
        CP 7:RET NC:ADD A,26
KEYR9   LD HL,TBKEY4:ADD A,L
        BIT 6,B:JR Z,$+4:ADD A,33
        LD L,A,D,(HL)
        LD E,0:CALL KEYR5
        LD A,D:RET Z
        INC A:CP #F1:RET Z:DEC A
        ADD A,#20:CP #B0:RET C
        ADD A,#30:RET

;***************************************

IEPX    DB 25
IEPY    DB 0
SYST    DB 0
CNTCUR  DB 0
BEGSCR  DB 0
RAWKEY  DB 0
KEYBUF  DB #FF,0,0,0,#FF,0,0,0

;***************************************

        ORG $^
TBKBIT

        DS 2
TBKEY2  DB "ٴ͹ʱɻ"
        DB "Խ͵۾ո"

;L IS NOT [#00..#0C] FOR TBKEY1
TBKEY1  DB "_!@#$%&'()",0,2
        DB 12,7,6,4,5,8,10,11,9,15,1,3
        DB "@101112131415161718190D1A"

TBKEY3  DB 126,"*?\",#1D,"{}^-+=.,;"
        DB #22,#1B,"<|>]/",#1C,"`[:"

TBKEY4
_DB ""
_DB ""

TBKEY5  DB 0,"*?",2,#1D,3,4
        DB "^"],5,"-+=.,;"
        DB #22,#1B,"<"],1
        DB ">]/",#1C,6,"[:"

TBMKEY  DB "@E100E005E00AE00F"
        DB "@E014E019E01EE223"

        DB "@8080808080808080"
        DB "@8080808080808005"
        DB "@8080808080808004"
        DB "@8080800380020100"
ETBKEY
;TOP OF SEGMENT

TBKEY0  DB ".ZXCVASDFGQWERT12345"
        DB "09876POIUY",#0D,"LKJH .MNB"

;***************************************

COLNOM  EQU 7
COLM    EQU 2
CURFLSH EQU 16'+8
HGT     EQU 22
MARKBIT EQU 7

;***************************************


