;***************************************
;UNI EDITOR EXIT: A-OUT_OF_LINE CODE
;B-PY C-X(BYTE) D-XMIN E-XMAX
;CF=1 CALL END_OF_LINE
;CF=0 A=PX
;CONTINUE=CALL IEDCONT

IED     PUSH AF
        LD (IEPX),A
        PUSH BC
        LD A,27:CALL SETBANK
        POP BC
        LD A,D,(IEXMIN),A
        LD A,E,(IEXMAX),A
        LD A,B,(IEPY),A
        CALL CRDA:LD A,E:OR C:LD E,A
        LD (IESCR),DE
        POP AF:CALL C,IEEND
        OR A:CALL IECOPY
        EI:HALT
        CALL PRMODES,PRCOL
IEDCONT CALL IED0
        LD HL,SYST
        BIT 2,(HL):RES 2,(HL)
        PUSH AF:CALL NZ,PRLN2:POP AF
        RET

IEDB    LD A,1
IEDO    OUT (#FE)
IED0    CALL CURON,PRCOL
        CALL PRLN
        CALL WTKEY
        XOR A:OUT (#FE),A
LASTK   EQU $+1:LD A,0:CP #20:JR C,IED2
        CALL IESETCH
        LD HL,(IEPX),H,BUFED[:INC L
        BIT 7,C:JR Z,IED1
        LD B,A
        LD A,(BUFED+80):CP 32:JR NZ,IEDB
        LD A,80:SUB L:LD C,A
        LD A,B:LD B,0
        LD HL,BUFED+79,DE,BUFED+80
        LDDR:EX DE,HL
IED1    LD (HL),A
        LD A,(IEPX):CALL IERGT1:JR IED0

IED2    ADD A,A:ADD A,IEDTBL]:LD L,A
        ADC A,IEDTBL[:SUB L:LD H,A
        LD A,(HL):INC HL
        LD H,(HL):LD L,A
        LD A,H:OR A:LD A,L:RET Z;OUTLINE
        LD DE,IED0:PUSH DE
        LD DE,(IEPX):JP (HL)

IEDTBL  DW 0,1,IECLR,2,3,4,5,6,IELFT
        DW IERGT,7,8,IEBSP,10,11,IEDEL
        DW IEBSPW,IERLAT,IECLOCK,13,14
        DW IELFTW,15,16,IERGTW,IEDELW
        DW IEOLD,IEHOM,IEINS,IEEND
        DW IERET,IERET

IESETCH PUSH AF:LD A,(SYST)
        RES 1,A:LD (SYST),A:POP AF:RET

IERLAT  LD A,#04:JR IEINS1
IECLOCK LD A,#02:JR IEINS1
IEINS   LD A,#80
IEINS1  XOR C:LD (KEYSTAT),A
        CALL PRMODES
IERET   RET

IECLR   OR A:CALL IECOPY
        LD HL,BUFED,BC,81'+#20
IECLR1  LD (HL),C:INC L:DJNZ IECLR1
        LD A,(IEXMIN)
IEPXCH  CALL IESETCH
IESETPX LD (IEPX),A,E,A:RET

IEOLD   SCF:CALL IECOPY,IESETCH:RET

IELFT   LD A,E
IEXMIN  EQU $+1:CP 0:RET Z
        DEC A:JR IESETPX

IERGT   LD A,E
IERGT1
IEXMAX  EQU $+1:CP 0:RET Z
        INC A:JR IESETPX

IEHOM   LD A,(IEXMIN):JR IESETPX

IEEND   LD HL,BUFED+81
        LD A,(IEXMIN),B,A,C,#20
IEEND1  DEC L:LD A,L:CP B:JR Z,IEEND2
        LD A,(HL):CP C:JR Z,IEEND1
IEEND2  LD A,(IEXMAX)
        CP L:JR C,IESETPX
        LD A,L:JR IESETPX

IEBSP   CALL IESETCH
        LD A,(IEXMIN):CP E
        LD A,9:JR Z,IEEXIT
        CALL IELFT:INC E:LD D,BUFED[
IEBSP1  BIT 7,C:JR Z,IEBSP2
        LD HL,DE:INC L
        LD A,81:SUB L
        LD C,A,B,0:LDIR
IEBSP2  LD A,#20:LD (DE),A:RET

IEDEL   CALL IESETCH
        INC E:LD D,BUFED[
        LD A,81:SUB E:LD B,A
        LD HL,DE,A,#20
IEDEL1  CP (HL):JR NZ,IEBSP1
        INC L:DJNZ IEDEL1
        LD A,12
IEEXIT  POP HL:RET

IECOPY  LD HL,BUFED,DE,BUFOLD,BC,81
        JR NC,$+3:EX DE,HL:LDIR:RET

IEBSPW
IELFTW
IERGTW
IEDELW  RET

WTKEY   LD HL,KEYSTAT
WTKEY1  EI:HALT:BIT 0,(HL):JR Z,WTKEY1
        RES 0,(HL):LD C,(HL):RET


CUR     LD A,(SYST):BIT 0,A:RET Z
        LD DE,(CURFLSH)
        LD HL,CNTCUR:LD A,(HL)
        CP E:PUSH AF
        INC A:CP D:JR C,$+3:XOR A
        LD (HL),A:POP AF
        JR CUROUT

CURON   LD HL,SYST:BIT 0,(HL):RES 0,(HL)
        PUSH HL
        CALL NZ,CUROFF1
        CALL CRDCUR
        XOR A:LD (CNTCUR),A
        SCF:CALL CUROUT
        POP HL:SET 0,(HL):RET

CUROFF  LD HL,SYST:RES 0,(HL)
CUROFF1 XOR A
CUROUT  LD D,0:JR NC,$+3:DEC D
MCUR    EQU $+1:LD BC,0
ACUR    EQU $+1:LD HL,0
_LD A,(HL):XOR D:AND B:XOR D:LD (HL),A
        INC L
_LD A,(HL):XOR D:AND C:XOR D:LD (HL),A
        RET

CRDCUR  LD HL,(IESCR),A,(IEPX)
        LD E,A:ADD A,A,A,E:LD C,A
        RRCA:RRCA
        AND #1F:ADD A,L:LD L,A
        LD A,H:OR 7:LD H,A
        LD A,C:AND 3:LD B,A
        LD A,3:LD E,#FF:JR Z,CRDCUR2
        SCF
CRDCUR1 RRA:RR E:RRA:RR E:DJNZ CRDCUR1
CRDCUR2 LD D,A
        LD (ACUR),HL,(MCUR),DE:RET

PRLN    LD A,(IEXMAX)
        INC A:LD L,A,H,BUFED[
        LD A,81:SUB L:LD B,A:XOR A
PRLN1   OR (HL):INC L:DJNZ PRLN1
        LD HL,SYST:RES 2,(HL)
        CP #20:JR Z,PRLN2:SET 2,(HL)
PRLN2   LD A,(IEXMAX),C,A
        LD A,(IEXMIN),B,A
IESCR   EQU $+1:LD DE,0:INC D
        LD A,C:SUB B
        PUSH AF,DE:RRA:SRL A
        LD HL,BUFED+1:CALL PR4L
        POP HL
        LD A,H:RRA:RRA:RRA
        AND #03:OR #58:LD H,A
        POP AF:PUSH AF
        LD B,A:ADD A,A,A,B:RRA:SRL A
        LD B,A,A,(BUFED)
        BIT 7,A:LD A,(COLNOM)
        JR Z,$+4:LD A,(COLM)
PRLN3   LD (HL),A:INC L:DJNZ PRLN3
        POP AF:AND 3:INC A:LD LY,A,HY,D
        LD H,FONT[+#12,B,FONT[
        LD C,(IX+0)
        LD L,(IX+1):SCF:CALL PRLN5
        LD C,(IX+2):OR A:CALL PRLN5
        LD L,(IX+3):SCF

PRLN5   DEC LY:INC LY:RET Z
        DEC LY:JR NZ,PRLN6
        LD A,(SYST):BIT 2,A
        LD L," ",C,L:JR Z,$+4:LD C,#1F
        JR C,PRLN6
        LD L,C,C," "
PRLN6   LD A,(IEPY):SUB HGT+1:JP NC,PR4B
        LD A,E:OR #E0:INC A:JP NZ,PR4B
        LD HY,6
PRLN7   LD A,(BC):OR (HL):INC A
        LD (DE),A:INC H,D,B
        DEC HY:JR NZ,PRLN7
        RET

